#include "Commands_Factions.h"

#include "GameForms.h"
#include "GameObjects.h"
#include "GameAPI.h"
#include "GameRTTI.h"
#include "GameBSExtraData.h"
#include "GameExtraData.h"

bool Cmd_GetFactionRank_Eval(COMMAND_ARGS_EVAL)
{
	SInt8 foundRank = -1;
	TESFaction* faction = (TESFaction*)arg1;
	if (faction)
	{
		bool bFoundRank = false;
		foundRank = GetExtraFactionRank(thisObj->extraDataList, faction);
		bFoundRank = ( -1 != foundRank );
		if (!bFoundRank) {
			TESActorBaseData* actorBase = DYNAMIC_CAST(thisObj->baseForm, TESForm, TESActorBaseData);
			if (actorBase)
			{
				foundRank = actorBase->GetFactionRank(faction);
				bFoundRank = true;
			}
		}
		if (bFoundRank && IsConsoleMode())
			Console_Print("GetFactionRank >> %.2f", *result);
	}

	*result = foundRank;
	return true;
}

bool Cmd_GetFactionRank_Execute(COMMAND_ARGS)
{
	TESFaction* faction;
	if (ExtractArgs(EXTRACT_ARGS, &faction))
	{
		return Cmd_GetFactionRank_Eval(thisObj, faction, 0, result);
	}
	return true;
}
