#include "Commands_Packages.h"

#include "GameForms.h"
#include "GameObjects.h"
#include "GameAPI.h"
#include "GameRTTI.h"
#include "GameBSExtraData.h"
#include "GameExtraData.h"
#include "GameProcess.h"

bool Cmd_GetDialogueTarget_Eval(COMMAND_ARGS_EVAL)
{
	*result = 0;
	UInt32* refResult = (UInt32*)result;
	*refResult = 0;
	BaseProcess* pProcess = NULL;
	TESPackage* pPackage = NULL;
	DialoguePackage* pDPackage = NULL;

	Actor* pActor = DYNAMIC_CAST(thisObj, TESForm, Actor);
	if (pActor)
		pProcess = pActor->baseProcess;
	if (pProcess) {
		pPackage = pProcess->GetCurrentPackage();
		//DumpClass(pPackage, 128);
	}
	if (pPackage) {
		pDPackage = DYNAMIC_CAST(pPackage, TESPackage, DialoguePackage);
		if (pDPackage) {
			if (pDPackage->target)
				*refResult = pDPackage->target->refID;
		}
		//DEBUG_MESSAGE("\t\tGDT E Actor:%x package:[%#10x] refResult:[%x]\n", pActor->refID, pPackage, *refResult);
	}

	if (IsConsoleMode())
		Console_Print("GetDialogueTarget >> %10X", *refResult);
	return true;
}

bool Cmd_GetDialogueTarget_Execute(COMMAND_ARGS)
{
	*result = 0;

	if(!thisObj)
		return true;

	//DEBUG_MESSAGE("\t\tGDT 0 Actor:%x target:[%x]\n", thisObj->refID, *result);
	bool rc = Cmd_GetDialogueTarget_Eval(thisObj, 0, 0, result);
	DEBUG_MESSAGE("\t\tGDT 1 Actor:%x target:[%x]\n", thisObj->refID, *result);
	return rc;
}

bool Cmd_GetDialogueSubject_Eval(COMMAND_ARGS_EVAL)
{
	*result = 0;
	UInt32* refResult = (UInt32*)result;
	*refResult = 0;
	BaseProcess* pProcess = NULL;
	TESPackage* pPackage = NULL;
	DialoguePackage* pDPackage = NULL;

	Actor* pActor = DYNAMIC_CAST(thisObj, TESForm, Actor);
	if (pActor)
		pProcess = pActor->baseProcess;
	if (pProcess) {
		pPackage = pProcess->GetCurrentPackage();
		//DumpClass(pPackage, 128);
	}
	if (pPackage) {
		pDPackage = DYNAMIC_CAST(pPackage, TESPackage, DialoguePackage);
		if (pDPackage) {
			if (pDPackage->subject)
				*refResult = pDPackage->subject->refID;
		}
		//DEBUG_MESSAGE("\t\tGDS E Actor:%x package:[%#10x] refResult:[%x]\n", pActor->refID, pPackage, *refResult);
	}

	if (IsConsoleMode())
		Console_Print("GetDialogueSubject >> %10X", *refResult);
	return true;
}

bool Cmd_GetDialogueSubject_Execute(COMMAND_ARGS)
{
	*result = 0;

	if(!thisObj)
		return true;

	//DEBUG_MESSAGE("\t\tGDS 0 Actor:%x subject:[%x]\n", thisObj->refID, *result);
	bool rc = Cmd_GetDialogueSubject_Eval(thisObj, 0, 0, result);
	DEBUG_MESSAGE("\t\tGDS 1 Actor:%x subject:[%x]\n", thisObj->refID, *result);
	return rc;
}

bool Cmd_GetDialogueSpeaker_Eval(COMMAND_ARGS_EVAL)
{
	*result = 0;
	UInt32* refResult = (UInt32*)result;
	*refResult = 0;
	BaseProcess* pProcess = NULL;
	TESPackage* pPackage = NULL;
	DialoguePackage* pDPackage = NULL;

	Actor* pActor = DYNAMIC_CAST(thisObj, TESForm, Actor);
	if (pActor)
		pProcess = pActor->baseProcess;
	if (pProcess) {
		pPackage = pProcess->GetCurrentPackage();
		//DumpClass(pPackage, 128);
	}
	if (pPackage) {
		pDPackage = DYNAMIC_CAST(pPackage, TESPackage, DialoguePackage);
		if (pDPackage) {
			if (pDPackage->speaker)
				*refResult = pDPackage->speaker->refID;
		}
		//DEBUG_MESSAGE("\t\tGDK E Actor:%x package:[%#10x] refResult:[%x]\n", pActor->refID, pPackage, *refResult);
	}

	if (IsConsoleMode())
		Console_Print("GetDialogueSpeaker >> %10X", *refResult);
	return true;
}

bool Cmd_GetDialogueSpeaker_Execute(COMMAND_ARGS)
{
	*result = 0;

	if(!thisObj)
		return true;

	//DEBUG_MESSAGE("\t\tGDK 0 Actor:%x subject:[%x]\n", thisObj->refID, *result);
	bool rc = Cmd_GetDialogueSpeaker_Eval(thisObj, 0, 0, result);
	DEBUG_MESSAGE("\t\tGDK 1 Actor:%x subject:[%x]\n", thisObj->refID, *result);
	return rc;
}

bool Cmd_SetPackageLocationReference_Execute(COMMAND_ARGS)
{
	*result = 0;

	//DEBUG_MESSAGE("\t\tSPL @\n");
	TESObjectREFR* pRefr = NULL;
	TESForm * pForm = NULL;
	TESPackage* pPackage = NULL;
	ExtractArgs(EXTRACT_ARGS, &pForm, &pRefr);
	if (!pRefr)
		if(!thisObj)
			return true;
		else
			pRefr = thisObj;
	//DEBUG_MESSAGE("\t\tSPL 0 Refr:%x\n", pRefr->refID);
	if (!pForm)
			return true;
	//DEBUG_MESSAGE("\t\tSPL 1 Package:[%x] Refr:%x\n", pForm, pRefr->refID);
	pPackage = DYNAMIC_CAST(pForm, TESForm, TESPackage);
	//DEBUG_MESSAGE("\t\tSPL 2 Package:[%x] Refr:%x\n", pPackage, pRefr->refID);
	if (pPackage) {
		//DEBUG_MESSAGE("\t\tSPL 3 Package:%x Refr:%x\n", pPackage->refID, pRefr->refID);
		TESPackage::LocationData * pLocation = TESPackage::LocationData::Create();
		//DEBUG_MESSAGE("\t\tSPL 4 Package:%x Refr:%x Location:[%x]\n", pPackage->refID, pRefr->refID, pLocation);
		if (pLocation) {
			pLocation->locationType = TESPackage::LocationData::kPackLocation_NearReference;
			pLocation->object.form = pRefr;
			if (pPackage->location) {
				pLocation->radius = pPackage->location->radius;
				FormHeap_Free(pPackage->location);
			}
			pPackage->location = pLocation;

			//DEBUG_MESSAGE("\t\tSPL 5 Package:%x Refr:%x Location:[%x]\n", pPackage->refID, pRefr->refID, pLocation);
		}
	}
	return true;
}

bool Cmd_SetPackageTargetReference_Execute(COMMAND_ARGS)	// Does not work! 
{
	*result = 0;

	DEBUG_MESSAGE("\t\tSPT @\n");
	TESObjectREFR* pRefr = NULL;
	TESForm * pForm = NULL;
	TESPackage* pPackage = NULL;
	ExtractArgs(EXTRACT_ARGS, &pForm, &pRefr);
	if (!pRefr)
		if(!thisObj)
			return true;
		else
			pRefr = thisObj;
	DEBUG_MESSAGE("\t\tSPT 0 Refr:%x\n", pRefr->refID);
	if (!pForm)
			return true;
	DEBUG_MESSAGE("\t\tSPT 1 Package:[%x] Refr:%x\n", pForm, pRefr->refID);
	pPackage = DYNAMIC_CAST(pForm, TESForm, TESPackage);
	DEBUG_MESSAGE("\t\tSPT 2 Package:[%x] Refr:%x\n", pPackage, pRefr->refID);
	if (pPackage) {
		DEBUG_MESSAGE("\t\tSPT 3 Package:%x Refr:%x Target:[%x]\n", pPackage->refID, pRefr->refID, pPackage->target);
		if (pPackage->target) {
			FormHeap_Free(pPackage->target);
			pPackage->target = NULL;
		}
		pPackage->SetTarget(pRefr);
		DEBUG_MESSAGE("\t\tSPT 4 Package:%x Refr:%x Target:[%x]\n", pPackage->refID, pRefr->refID, pPackage->target);
	}
	return true;
}
